#include <stdio.h>
#include <unistd.h>

//just to be on the safe side
#define REALLY_SLOW_IO
#include <asm/io.h>

static inline int
superio_inb(int reg) {
	outb(reg, 0x33);
	return inb(0x34);
}

int main(int argc,char* argv[]) {
	int i;
	int id1,id2;
	int address;
	//turn io permissions on
	ioperm(0x2e,16,1);

	//enter pnp mode
        outb(0x87, 0x2e);
        outb(0x01, 0x2e);
        outb(0x55, 0x2e);
        outb(0x55, 0x2e);

	//get chip id
	outb(0x20,0x2e);
	id1=inb(0x2f);
	outb(0x21,0x2e);
	id2=inb(0x2f);

	if(id1!=0x87 && id2!=0x16) {
		printf("it8716f not found chip id:%2x %2x \naborting\n",id1,id2);
		return 1;
	}

	//get ec address
	outb(0x7,0x2e);	//write to index register 0x7 ldn 04
	outb(0x4,0x2f);

	outb(0x60,0x2e);
	address=inb(0x2f);
	address<<=8;
	outb(0x61,0x2e);
	address|=inb(0x2f);
	printf("chipaddress: %x\n",address);

	//get io permissions for ec
	ioperm(address,16,1);
	
	//read ec registers
	for(i=0x0; i<=0xff; i++) {
		outb(i,address+5);
		printf("%2x %2x\n",i,inb(address+6));
	}

	//release io permissions for ec
	ioperm(address,16,0);

	//superio exit
	outb(0x02,0x2e);
	outb(0x02,0x2f);

	//turn io permissions off
	ioperm(0x2e,16,0);
	return 0;
}
